<?php

$access_key = 'ak from www.ksyun.com';
$secret_key = 'sk from www.ksyun.com';

$post_data = '{
    "guard_id": "1547778774476511751",
    "image_url": "https://ks3-cn-beijing.ksyun.com/datasets/sdk/chenshuibian.png"
}';

$method = "POST";
$service = "kir";
$host = "kir.api.ksyun.com";
$region = 'cn-beijing-6';
$endpoint = 'http://' . $host;
$action = 'ClassifyImageGuard';
$version = '2019-01-18';
$contenttype = 'application/json';
$request_parameters = 'Action=' . $action . '&Version=' . $version;


function sign($key, $msg) {
    return hash_hmac("sha256", $msg,  $key, true);
}
function getSignatureKey($key, $dateStamp, $regionName, $serviceName) {
    $kDate = sign('AWS4' . $key, $dateStamp);
    $kRegion = sign($kDate, $regionName);
    $kService = sign($kRegion, $serviceName);
    $kSigning = sign($kService, 'aws4_request');
    return $kSigning;
}




date_default_timezone_set('UTC');
$time = time() ;
$amzdate = date("Ymd",$time)."T".date("His",$time) . "Z";
$datestamp = date("Ymd",$time);
#$amzdate = '20180202T035703Z';
#$datestamp = '20180202';


$canonical_uri = '/';

$canonical_querystring = $request_parameters;

$canonical_headers = 'content-type:' . $contenttype . "\n" . 'host:' . $host . "\n" . 'x-amz-date:' . $amzdate . "\n";

$signed_headers = 'content-type;host;x-amz-date';

$payload_hash = hash("sha256", $post_data);

echo 'payload_hash:' . $payload_hash. "\n";

$canonical_request = $method . "\n" . $canonical_uri . "\n" . $canonical_querystring . "\n" . $canonical_headers . "\n" . $signed_headers . "\n" . $payload_hash;

echo 'canonical_request:' . $canonical_request  . "\n";

$algorithm = 'AWS4-HMAC-SHA256';
$credential_scope = $datestamp . '/' . $region . '/' . $service . '/' . 'aws4_request';
$string_to_sign = $algorithm . "\n" .  $amzdate . "\n" .  $credential_scope . "\n" . hash("sha256", $canonical_request); 

echo 'string_to_sign:' . $string_to_sign . "\n";

$signing_key = getSignatureKey($secret_key, $datestamp, $region, $service);

#echo $secret_key . "\n" . $datestamp . "\n" . $region . "\n" .  $service;
#echo $signing_key . "\n";

$signature = hash_hmac("sha256", $string_to_sign, $signing_key);

echo 'signature:' . $signature . "\n";

#echo "sign:" . $signature . "\n";
$authorization_header = $algorithm . ' ' . 'Credential=' . $access_key . '/' . $credential_scope . ', ' .  'SignedHeaders=' . $signed_headers . ', ' . 'Signature=' . $signature;

echo 'authorization_header:' . $authorization_header . "\n";

$request_url = $endpoint . '?' . $canonical_querystring;

$ch = curl_init($request_url);
curl_setopt($ch, CURLOPT_POST, 1);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data);
curl_setopt($ch, CURLOPT_HTTPHEADER, array("x-amz-date:$amzdate", "Authorization:$authorization_header", "Content-Type:$contenttype"));

echo "\n\n-------------result--------------\n\n";

$result = json_decode(curl_exec($ch));


var_dump($result);




?>
