<?php

function sign($key, $msg) {
    return hash_hmac("sha256", $msg,  $key, true);
}
function getSignatureKey($key, $dateStamp, $regionName, $serviceName) {
    $kDate = sign('AWS4' . $key, $dateStamp);
    $kRegion = sign($kDate, $regionName);
    $kService = sign($kRegion, $serviceName);
    $kSigning = sign($kService, 'aws4_request');
    return $kSigning;
}

function apiRequest($action, $version, $access_key, $secret_key, $host,  $service, $post_data) {
    $request_url = 'http://' . $host . '?' . 'Action=' . $action . '&Version=' . $version;
    $data_array = json_decode($post_data, true);

    $new_array = array();
    $post_data_array = [];
    for ($x = 0; $x < count($data_array["image_urls"]); $x++) {
        $new_array["guard_id"] = $data_array["guard_id"];
        $new_array["image_url"] = $data_array["image_urls"][$x];
        $post_data_array[$x] = json_encode($new_array);
    }
    //var_dump($post_data_array[0]);

    $mh = curl_multi_init();
    
    $ch_list = array();
    
    for ($x = 0; $x < count($post_data_array); $x++) {

        $ch = curl_init($request_url);
        $ch_list[$x] = $ch;
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post_data_array[$x]);
        curl_setopt($ch, CURLOPT_HTTPHEADER, getHeader($action, $version, $access_key, $secret_key, $host,  $service, $post_data_array[$x]));
         
        //curl_setopt($ch_list[$url], CURLOPT_SSL_VERIFYPEER, false);
        curl_multi_add_handle($mh, $ch);
    }
    //var_dump("ch_list" . count($ch_list));
     
    $running = null;
    do {
        curl_multi_exec($mh, $running);
    } while ($running);
    $results = [];
    // 実行結果の取得
    for ($x = 0; $x < count($ch_list); $x++) {
         
        $results[$x] = curl_getinfo($ch_list[$x]);
        $results[$x]["content"] = curl_multi_getcontent($ch_list[$x]);
         
        curl_multi_remove_handle($mh, $ch_list[$x]);
        curl_close($ch_list[$x]);
    }
     
    curl_multi_close($mh);
     
    return $results;
}

function getHeader($action, $version, $access_key, $secret_key, $host,  $service, $post_data) {
    $request_parameters = 'Action=' . $action . '&Version=' . $version;
    $region = 'cn-beijing-6';
    $endpoint = 'http://' . $host;

    $contenttype = 'application/json';


    date_default_timezone_set('UTC');
    $time = time() ;
    $amzdate = date("Ymd",$time)."T".date("His",$time) . "Z";
    $datestamp = date("Ymd",$time);
    // $amzdate = '20190614T114803Z';
    // $datestamp = '20190614';


    $canonical_uri = '/';

    $canonical_querystring = $request_parameters;

    $canonical_headers = 'content-type:' . $contenttype . "\n" . 'host:' . $host . "\n" . 'x-amz-date:' . $amzdate . "\n";

    $signed_headers = 'content-type;host;x-amz-date';

    $payload_hash = hash("sha256", $post_data);

    echo 'payload_hash:' . $payload_hash. "\n";

    $canonical_request = "POST" . "\n" . $canonical_uri . "\n" . $canonical_querystring . "\n" . $canonical_headers . "\n" . $signed_headers . "\n" . $payload_hash;

    echo 'canonical_request:' . $canonical_request  . "\n";

    $algorithm = 'AWS4-HMAC-SHA256';
    $credential_scope = $datestamp . '/' . $region . '/' . $service . '/' . 'aws4_request';
    $string_to_sign = $algorithm . "\n" .  $amzdate . "\n" .  $credential_scope . "\n" . hash("sha256", $canonical_request); 

    echo 'string_to_sign:' . $string_to_sign . "\n";

    $signing_key = getSignatureKey($secret_key, $datestamp, $region, $service);

    #echo $secret_key . "\n" . $datestamp . "\n" . $region . "\n" .  $service;
    #echo $signing_key . "\n";

    $signature = hash_hmac("sha256", $string_to_sign, $signing_key);

    echo 'signature:' . $signature . "\n";

    #echo "sign:" . $signature . "\n";
    $authorization_header = $algorithm . ' ' . 'Credential=' . $access_key . '/' . $credential_scope . ', ' .  'SignedHeaders=' . $signed_headers . ', ' . 'Signature=' . $signature;

    echo 'authorization_header:' . $authorization_header . "\n";

    return array("x-amz-date:$amzdate", "Authorization:$authorization_header", "Content-Type:$contenttype");
}




$access_key = 'ak from ksyun.com';
$secret_key = 'ak from ksyun.com';
$action = 'ClassifyImageGuard';
$version = '2019-01-18';
$service = "kir";
$host = "kir.api.ksyun.com";

$post_data = '{
    "guard_id": "guard_id from ksyun.com",
    "image_urls": ["https://ks3-cn-beijing.ksyun.com/datasets/sdk/chenshuibian.png"]
}';



var_dump(apiRequest($action, $version, $access_key, $secret_key, $host,  $service, $post_data));

?>
